package com.diss.omppapp.api;

import com.diss.omppapp.entities.QuestionEntity;
import com.diss.omppapp.pojo.AnswerSet;
import com.diss.omppapp.services.MinutePaperService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
public class MinutePaperController {

    @Autowired
    private MinutePaperService minutePaperService;

    @PostMapping(value = "/getPaperQuestions",consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    public List<QuestionEntity> getPaperQuestions(@RequestBody Map<String,String> request) {
       return minutePaperService.getQuestions(request.get("paperId"));
    }

    @PostMapping(value = "/getPaperAnswers",consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    public List<AnswerSet> getPaperAnswers(@RequestBody Map<String,String> request) {
        return minutePaperService.getAnswerSets(request.get("paperId"));
    }

}
