package com.diss.omppapp.api;

import com.diss.omppapp.entities.AnswerEntity;
import com.diss.omppapp.entities.ClassEntity;
import com.diss.omppapp.entities.MinutePaperEntity;
import com.diss.omppapp.pojo.ResponseDetails;
import com.diss.omppapp.pojo.ResponseDetailsWrapper;
import com.diss.omppapp.services.ClassInfoService;
import com.diss.omppapp.services.StudentInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@RestController
public class StudentController {

    @Autowired
    private StudentInfoService studentInfoService;

    @Autowired
    private ClassInfoService classInfoService;

    @PostMapping(value = "/getStudentClasses",consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    public List<ClassEntity> getClassList(@RequestBody Map<String,String> request) {
        return classInfoService.getClasses(request.get("username"));
    }

    @PostMapping(value = "/getOpenPapers",consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    public List<MinutePaperEntity> getOpenPapers(@RequestBody Map<String,String> request) {

        return studentInfoService.getOpenPapers(request.get("username"), classInfoService.getClasses(request.get("username")));
    }

    @PostMapping(value = "/getSubmittedClassPapers",consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    public List<MinutePaperEntity> getSubmittedClassPapers(@RequestBody Map<String,String> request) {
        return studentInfoService.getClosedClassPapers(request.get("username"),request.get("classCode"));
    }

    @PostMapping(value = "/getStudentAnswers",consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    public List<AnswerEntity> getStudentAnswers(@RequestBody Map<String,String> request) {
        return studentInfoService.getStudentAnswers(request.get("username"),request.get("paperId"));
    }

    @PostMapping(value = "/saveDraft",consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    public void saveDraft(@RequestBody ResponseDetailsWrapper response) {
        studentInfoService.save(response,false);
    }

    @PostMapping(value = "/submitResponse",consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    public void submitResponse(@RequestBody ResponseDetailsWrapper response) {
        studentInfoService.save(response,true);
    }

}
