package com.diss.omppapp.repositories;

import com.diss.omppapp.entities.AnswerEntity;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import javax.transaction.Transactional;
import java.util.List;
import java.util.Optional;

@Repository
public interface AnswerEntityRepository extends CrudRepository<AnswerEntity, Integer> {
    Optional<List<AnswerEntity>> findAllByUsernameAndSubmitted(String username, Boolean submitted);
    Optional<List<AnswerEntity>> findAllByPaperIdAndSubmitted(int paperId, boolean submitted);
    Optional<List<AnswerEntity>> findAllByUsernameAndPaperIdOrderByAnswerIdAsc(String username, int paperId);
    Optional<AnswerEntity> findByUsernameAndPaperIdAndQuestionId(String username, int paperId, int QuestionId);
    boolean existsByUsernameAndPaperIdAndQuestionId(String username, int paperId, int QuestionId);
    boolean existsByUsernameAndPaperId(String username, int paperId);
    @Transactional
    void deleteByPaperId(int paperId);
}
