package com.diss.omppapp.repositories;

import com.diss.omppapp.entities.MinutePaperEntity;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import javax.transaction.Transactional;
import java.util.List;
import java.util.Optional;

@Repository
public interface MinutePaperEntityRepository extends CrudRepository<MinutePaperEntity, Integer> {
    Optional<MinutePaperEntity> findByPaperId(int paperId);
    Optional<MinutePaperEntity> findByPaperIdAndAnonymous(int paperId, boolean anonymous);
    Optional<List<MinutePaperEntity>> findAllByClassCodeAndTemplate(String classCode, Boolean isTemplate);
    Optional<List<MinutePaperEntity>> findAllByUsernameAndTemplate(String classCode, Boolean isTemplate);
    Optional<List<MinutePaperEntity>> findAllByUsernameAndClassCodeAndTemplate(String username, String classCode, boolean template);
    int countAllByClassCode(String classCode);
    boolean existsByPaperId(int paperId);
    @Transactional
    void deleteByPaperId(int paperId);
}
